unit fMain;

interface
uses
   SysUtils, Forms, Dialogs, Controls, Classes, ComCtrls, ExtCtrls, Buttons, StdCtrls;
   
type
  TPossible = set of 0..9;
  TCheckResultOpt= (BadLength=1,Capitals=2,Yes=3,No=4);
  TCheckResult = set of TCheckResultOpt;
  TMyDigit = record
        sDigit:string;
        aDigit:TPossible;
  end;
type
  TfrmMain = class(TForm)
    edtCode: TEdit;
    btnNewGame: TBitBtn;
    pnlTop: TPanel;
    pnlMain: TPanel;
    btnSpeti: TBitBtn;
    pnlTrys: TPanel;
    lvTrys: TListView;
    rb4: TRadioButton;
    rb5: TRadioButton;
    rb6: TRadioButton;
    procedure btnSpetiClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure btnNewGameClick(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormCanResize(Sender: TObject; var NewWidth,
      NewHeight: Integer; var Resize: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
    CI_HowChars:integer;
    KartuSpeta:integer;
    MyDigit:TMyDigit;
    procedure NewGame();
    function GenMyDigit():TMyDigit;
    function CheckMyDigit(EnDigit:string;MyDigit:TMyDigit;var Digits,Positions:integer):TCheckResult;

  end;

var
  frmMain: TfrmMain;

implementation

{$R *.dfm}
procedure TfrmMain.FormCreate(Sender: TObject);
begin
  rb4.Checked:=true;
  edtCode.Text:='';
  NewGame();
end;

function TfrmMain.GenMyDigit():TMyDigit;
var
 m,xrandom:integer;
begin
  with result do begin
    sDigit:='';                                                                  // issivalome pradinius duomenis
    aDigit:=[];                                                                  //
    m:=1;
    Randomize;                                                                   // kad labai smarkiai nesikartotu..
    while m<=CI_HowChars do begin
       xrandom:=random(9);
       if not (xrandom  in aDigit) then begin                                    // jeigu dar nera tokio skaicaus...
           sDigit:=sDigit+inttostr(xrandom);
           aDigit:=aDigit+[xrandom];
           inc(m);
       end;
    end;
  end;
end;

function TfrmMain.CheckMyDigit(EnDigit:string;MyDigit:TMyDigit;var Digits,Positions:integer):TCheckResult;
var m,l,c:integer;
str:string;
begin
  result:=[];
  str:=EnDigit;
  l:=length(EnDigit);
  Digits:=0;Positions:=0;
  if (l=CI_HowChars) then begin                                                  //ar geras ilgis ?
      with MyDigit do begin
        for m:=1 to l do begin                                                   // tikrinsime visus kodo simbolius
            if ord(str[m]) in [$30..$39] then begin                              // ar kodo simbolis yra skaicius???  
                c:=ord(str[m])-$30;                                              // koks tai skaicius??
                if c in MyDigit.aDigit then inc(Digits);                         // ar jis yra musu sugalvotame skaiciuje? taip =>Digits++
                if str[m] = MyDigit.sDigit[m] then inc(Positions);               // ar jis atitinka musu sugalvoto skaiciaus pozicija? taip => pozicijos++
            end else result:=[Capitals];                                         // buvo raides.. :( pasizymime...
        end
      end;
  end else result:=[BadLength];                                                  // blogas ilgis :(( pasizymime...
  if (result=[]) and (digits=CI_HowChars) and (positions=CI_HowChars) then result:=[Yes]          // tikriname ar zaidimo pabaiga (atspetos visos pozicijos,ir visi skaiciai uztektu positions=CI_HowChars
                                                                      else result:=result+[No];
end;

procedure TfrmMain.NewGame();
begin
        if rb4.Checked then CI_HowChars:=4
  else  if rb5.Checked then CI_HowChars:=5
  else  if rb6.Checked then CI_HowChars:=6;
  KartuSpeta:=0;
  lvTrys.Items.Clear;
  MyDigit:=GenMyDigit();
end;

procedure TfrmMain.btnSpetiClick(Sender: TObject);
var
chValue:TCheckResult;
Positions,Digits:integer;
tryvalue:boolean;
tli:TListItem;
code:string;
begin
tryvalue:=false;
code:=trim(edtCode.Text);
chValue:=CheckMyDigit(code,MyDigit,Digits,Positions);
if Capitals in chValue then showmessage('Raids negalimos kode...') else
if BadLength in chValue then showmessage('Kodas turi buti '+inttostr(CI_HowChars)+ ' simboli ilgio' ) else
  tryvalue:=true;

if tryvalue then begin                                                          //kadangi reikia parodyti ir paskutini spejima naudojame tryvalue... 
  inc(KartuSpeta);
  tli:=self.lvTrys.Items.Add;
  with tli do begin
      Caption:=inttostr(KartuSpeta);
      SubItems.Add(code);
      SubItems.Add(inttostr(Positions));
      SubItems.Add(inttostr(Digits));
  end;
  if Yes in chValue then begin
    ShowMessage('Sveikinu! Js atspjote skaii! per '+inttostr(KartuSpeta)+'.Jis Yra'+Code);
    btnSpeti.Enabled:=false;
  end;
end;

end;

procedure TfrmMain.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if (ActiveControl=edtCode) and (key =#13) then btnSpetiClick(self);
end;

procedure TfrmMain.btnNewGameClick(Sender: TObject);
begin
  NewGame();
end;

procedure TfrmMain.FormResize(Sender: TObject);
begin
  edtCode.Width:=pnlMain.Width - btnSpeti.Width - 23;
end;

procedure TfrmMain.FormCanResize(Sender: TObject; var NewWidth,
  NewHeight: Integer; var Resize: Boolean);
begin
  if NewWidth <350 then resize:=false;
  if (NewHeight- pnlMain.Height - pnlTop.Height)<100 then resize:=false;
end;

end.
